
%  chemElement_ontology.pl


% resolve_ref requires is_ontology_term/1
% to identify all terms in the ontology

is_ontology_term(X):- 
	element(_,X,_).
is_ontology_term(X):- 
	element(_,_,X).


% coreference requires: 

% class_in_ontology/1
class_in_ontology(Word):- 
	element(_,Word,_).

%superclass_in_ontology/1
superclass_in_ontology(A):- 
	element(_,_,A).

% class_superclass_in_ontology/2
class_superclass_in_ontology(Word, Elementclass):- 
	element(_,Word, Elementclass).

% abbreviation/1
abbreviation_in_ontology(Word):- 
	element(Word,_,_).

% abbrev_class_in_ontology/2
abbrev_class_in_ontology(Symbol, Word):- 
	element(Symbol, Word, _).



%Appendix C
%Chemical Elements Ontology
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%
%% element/3
%% element(Symbol, Word, Elementclass)
%%
%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
element(ac, actinium, actinides).
element(ag, silver,transitionmetals).
element(al, aluminum, metals).
element(am, americium,actinides).
element(ar, argon, noblegasses).
element(as, arsenic, metalloidnonmetals).
element(at, astatine, halogens).
element(au, gold,transitionmetals).
element(b, boron, metalloidnonmetals).
element(bh, bohrium, transactinides).
element(ba, barium, alkaliearthmetals).
element(be, beryllium, alkaliearthmetals).
element(bi, bismuth, metals).
element(bk, berkelium,actinides).
element(br, bromine, halogens).
element(c, carbon, nonmetals).
element(ca, calcium, alkaliearthmetals).
element(cd, cadmium,transitionmetals).
element(ce, cerium,lanthanides).
element(cf, californium,actinides).
element(cl, chlorine, halogens).
element(cm, curium,actinides).
element(co, cobalt,transitionmetals).
element(cr, chromium,transitionmetals).
element(cs, cesium, alkalimetals).
element(cu, copper,transitionmetals).
element(db, dubnium, transactinides).
element(dy, dysprosium,lanthanides).
element(er, erbium,lanthanides).
element(es, einsteinium,actinides).
element(eu, europium,lanthanides).
element(f,fluorine, halogens).
element(fe,iron,transitionmetals).
element(fm, fermium,actinides).
element(fr, francium, alkalimetals).
element(ga, gallium, metals).
element(gd, gadolinium,lanthanides).
element(ge, germanium, metalloidmetals).
element(h,hydrogen, nonmetals).
element(hf, hafnium,transitionmetals).
element(hg, mercury,transitionmetals).
element(hi, helium, noblegasses).
element(ho, holmium,lanthanides).
element(hs, hassium,transactinides).
element(i,iodine, halogens).
element(in, indium, metals).
element(ir,iridium,transitionmetals).
element(k, potassium, alkalimetals).
element(kr, krypton, noblegasses).
element(la, lanthanum,lanthanides).
element(li, lithium, alkalimetals).
element(lr, lawrencium,actinides).
element(lu, lutetium,lanthanides).
element(md, mendelevium,actinides).
element(mg, magnesium, alkaliearthmetals).
element(mn, manganese,transitionmetals).
element(mo, molybdenum,transitionmetals).
element(mt, meitnerium,transactinides).
element(n, nitrogen, nonmetals).
element(na, sodium, alkalimetals).
element(nb, niobium,transitionmetals).
element(nd, neodymium,lanthanides).
element(ne, neon, noblegasses).
element(ni, nickel,transitionmetals).
element(no, nobelium,actinides).
element(np, neptunium,actinides).
element(o, oxygen, nonmetals).
element(os, osmium,transitionmetals).
element(p, phosphorus, nonmetals).
element(pa, protactinium,actinides).
element(pb, lead, metals).
element(pd, palladium,transitionmetals).
element(pm, promethium,lanthanides).
element(po, polonium, metalloidmetals).
element(pr, praseodymium,lanthanides).
element(pt, platinum,transitionmetals).
element(pu, plutonium,actinides).
element(ra, radium, alkaliearthmetals).
element(rb, rubidium, alkalimetals).
element(re, rhenium,transitionmetals).
element(rf, rutherfordium, transactinides).
element(rh, rhodium,transitionmetals).
element(rn, radon, noblegasses).
element(ru, ruthenium,transitionmetals).
element(s, sulfur, nonmetals).
element(sb, antimony, metalloidmetals).
element(sc, scandium,transitionmetals).
element(se, selenium, nonmetals).
element(sg, seaborgium, transactinides).
element(si, silicon, metalloidnonmetals).
element(sm, samarium,lanthanides).
element(sn, tin, metals).
element(sr, strontium, alkaliearthmetals).
element(ta, tantalum,transitionmetals).
element(tb, terbium,lanthanides).
element(tc, technetium,transitionmetals).
element(te, tellurium, metalloidnonmetals).
element(th,thorium,actinides).
element(ti, titanium,transitionmetals).
element(tl, thallium, metals).
element(tm, thulium,lanthanides).
element(u, uranium,actinides).
element(v, vanadium,transitionmetals).
element(w, tungsten,transitionmetals).
element(xi, xenon, noblegasses).
element(yb, ytterbium,lanthanides).
element(yb, yttrium,transitionmetals).
element(zn, zinc,transitionmetals).
element(zr, zirconium,transitionmetals).

%---------------------------------------------
% namedata.pl would provide these:

name('John').
name('Smith').

% wordnet would provide these:
hyp(a,a).
s(a,a,a,a,a,a).

