
% random selection of texts
% result is a list of (No) values 1...Max inclusive


tst:-   go(training,POS),!,
	training_POS(1,POS,POS1),!,
	testing_POS(1,POS,POS2),!,
	length(POS,Lpos),
	length(POS1,Lpos1),
	length(POS2,Lpos2),
	nl,write('length: '),write(Lpos),write('='),
	write(Lpos1),write('+'),write(Lpos2),!,
	mck(POS,POS1,POS2), write(' OK'),nl.

tst_t:-   extract_target(training,POS),!,
	training_TGT(1,POS,POS1),!,
	testing_TGT(1,POS,POS2),!,
	length(POS,Lpos),
	length(POS1,Lpos1),
	length(POS2,Lpos2),
	nl,write('length: '),write(Lpos),write('='),
	write(Lpos1),write('+'),write(Lpos2),!,
	mck(POS,POS1,POS2), write(' OK'),nl.

mck(POS,POS1,_):-
	member(X,POS1),
	not(member(X,POS)),!,write('1'),write(X),fail.

mck(POS,_,POS2):-
	member(X,POS2),
	not(member(X,POS)),!,write('2'),write(X),fail.
mck(_,POS1,POS2):-
	member(X,POS1),
	member(X,POS2),!,write('3'),write(X),fail.
mck(_,_,_).

training_POS(I,POSList,POSListRes):-
	test_sentences_list(I,List),
	delete_all_pos(List,POSList,POSListRes).

testing_POS(I,POSList,POSListRes):-
	test_sentences_list(I,List),
	keep_all_pos(POSList,List,POSListRes).

keep_all_pos([],_,[]):-!.
keep_all_pos([posSent(I,J,K)|L],List,[posSent(I,J,K)|POSListRes]):-
	member(I,List),!,
	keep_all_pos(L,List,POSListRes).
keep_all_pos([_|L],List,POSListRes):-!,
	keep_all_pos(L,List,POSListRes).

delete_all_pos([],POSList,POSList):-!.
delete_all_pos([I|List],POSList,POSListRes):-
	delete_all_sent(POSList,I,POSList1),
	delete_all_pos(List,POSList1,POSListRes).


delete_all_sent([],_,[]):-!.
delete_all_sent([posSent(Sent,_,_)|POSList],Sent,POSList1):-
	delete_all_sent(POSList,Sent,POSList1).
delete_all_sent([posSent(X,Y,Z)|POSList],Word,[posSent(X,Y,Z)|POSList1]):-
	delete_all_sent(POSList,Word,POSList1).


training_TGT(I,TGTList,TGTListRes):-
	test_sentences_list(I,List),
	delete_all_TGT(List,TGTList,TGTListRes).

testing_TGT(I,TGTList,TGTListRes):-
	test_sentences_list(I,List),
	keep_all_TGT(TGTList,List,TGTListRes).

keep_all_TGT([],_,[]):-!.
keep_all_TGT([[I,II]|L],List,[[I,II]|TGTListRes]):-
	member(I,List),!,
	keep_all_TGT(L,List,TGTListRes).
keep_all_TGT([_|L],List,TGTListRes):-!,
	keep_all_TGT(L,List,TGTListRes).

delete_all_TGT([],TGTList,TGTList):-!.
delete_all_TGT([I|List],TGTList,TGTListRes):-
	delete_all_tgts(TGTList,I,TGTList1),
	delete_all_TGT(List,TGTList1,TGTListRes).


delete_all_tgts([],_,[]):-!.
delete_all_tgts([[Sent,_]|TGTList],Sent,TGTList1):-
	delete_all_tgts(TGTList,Sent,TGTList1).
delete_all_tgts([S|TGTList],Sent,[S|TGTList1]):-
	delete_all_tgts(TGTList,Sent,TGTList1).


%set_of_random(68,205,L).

test_sentences_list(1, [6, 48, 178, 130, 155, 86, 100, 44, 76, 75, 91, 174, 121, 110, 26, 36, 182, 189, 95, 192, 81, 37, 46, 102, 89, 99, 18, 133, 65, 152, 23, 8, 191, 107, 119, 123, 94, 72, 73, 41, 82, 200, 14, 147, 183, 187, 161, 21, 160, 202, 63, 171, 106, 159, 185, 168, 58, 165, 120, 93, 5, 190, 24, 111, 50, 53, 131, 195]).

test_sentences_list(2,[130, 40, 150, 24, 177, 157, 61, 198, 22, 112, 182, 158, 65, 78, 185, 28, 181, 127, 174, 160, 87, 94, 151, 85, 196, 167, 183, 136, 53, 154, 114, 31, 91, 5, 118, 128, 37, 45, 51, 125, 145, 60, 137, 164, 88, 8, 7, 205, 104, 106, 59, 113, 30, 23, 62, 108, 117, 11, 82, 81, 34, 97, 190, 139, 109, 110, 103, 63]).

test_sentences_list(3,[114, 61, 18, 57, 17, 168, 83, 136, 135, 201, 79, 108, 162, 140, 54, 152, 95, 102, 8, 115, 97, 70, 28, 4, 121, 178, 128, 33, 153, 98, 106, 125, 20, 172, 55, 154, 194, 12, 42, 49, 85, 101, 10, 117, 43, 64, 92, 72, 110, 32, 77, 89, 24, 31, 181, 46, 76, 74, 187, 204, 93, 159, 171, 142, 182, 44, 113, 143]).

test_sentences_list(4,[122, 10, 46, 169, 160, 39, 164, 80, 78, 63, 23, 6, 82, 124, 59, 119, 96, 8, 150, 61, 77, 44, 131, 91, 68, 81, 200, 21, 57, 73, 186, 86, 123, 38, 168, 140, 110, 139, 47, 22, 26, 192, 3, 144, 133, 191, 182, 51, 95, 45, 120, 97, 170, 93, 121, 72, 190, 165, 67, 49, 58, 12, 102, 167, 205, 1, 159, 89]).

test_sentences_list(5,[144, 179, 32, 132, 84, 49, 126, 149, 172, 106, 136, 87, 143, 5, 177, 102, 69, 148, 146, 31, 45, 4, 98, 197, 147, 11, 96, 187, 169, 162, 103, 42, 36, 89, 20, 199, 154, 114, 40, 15, 34, 17, 37, 50, 99, 26, 2, 54, 86, 164, 46, 140, 85, 173, 78, 60, 166, 23, 41, 141, 158, 44, 100, 7, 155, 202, 201, 109]).

test_sentences_list(6,[185, 85, 133, 7, 155, 112, 147, 58, 128, 92, 20, 14, 89, 119, 88, 29, 101, 154, 25, 168, 66, 57, 83, 148, 64, 53, 63, 84, 109, 79, 204, 135, 99, 90, 59, 140, 87, 129, 73, 51, 163, 100, 110, 68, 184, 105, 18, 13, 75, 47, 142, 174, 115, 188, 86, 178, 183, 113, 77, 82, 156, 9, 137, 11, 182, 37, 170, 179]).

test_sentences_list(7,[42, 100, 176, 53, 147, 1, 56, 61, 173, 57, 149, 198, 69, 127, 66, 203, 35, 179, 60, 186, 95, 70, 39, 159, 31, 155, 145, 86, 41, 150, 156, 106, 40, 55, 165, 17, 157, 63, 115, 72, 178, 71, 91, 54, 85, 193, 146, 142, 38, 88, 13, 151, 114, 199, 136, 139, 111, 16, 52, 81, 120, 102, 101, 108, 77, 197, 143, 10]).

test_sentences_list(8,[14, 173, 127, 61, 75, 123, 7, 100, 21, 165, 37, 147, 187, 35, 142, 159, 55, 39, 88, 65, 111, 174, 94, 19, 148, 157, 73, 54, 190, 181, 67, 179, 46, 64, 99, 47, 151, 204, 143, 186, 103, 70, 60, 183, 95, 90, 129, 154, 150, 28, 152, 93, 172, 96, 192, 12, 79, 20, 114, 23, 69, 169, 31, 108, 171, 101, 74, 196]).

test_sentences_list(9,[119, 17, 101, 131, 185, 121, 126, 38, 196, 190, 47, 161, 112, 111, 186, 133, 145, 46, 86, 127, 153, 198, 92, 74, 36, 184, 4, 168, 33, 7, 20, 163, 28, 32, 140, 90, 132, 183, 130, 138, 60, 125, 23, 137, 64, 128, 62, 195, 5, 55, 188, 94, 56, 42, 113, 120, 147, 76, 182, 193, 22, 144, 104, 162, 164, 199, 192, 71]).

test_sentences_list(10,[87, 41, 101, 63, 93, 71, 130, 196, 64, 164, 103, 90, 146, 129, 51, 131, 82, 179, 125, 166, 83, 35, 173, 23, 144, 138, 30, 42, 169, 81, 62, 68, 200, 102, 55, 106, 74, 203, 73, 167, 104, 47, 78, 4, 120, 89, 199, 59, 97, 34, 54, 112, 94, 6, 155, 186, 99, 85, 1, 172, 143, 159, 29, 58, 32, 113, 108, 174]).


set_of_random(No,Max,S):-
    No =< Max,
    rep_get_rand(No,Max,[],R),
    rep_addone(R,S).

rep_addone([],[]):-!.
rep_addone([I|J],[II|K]):-
	II is I + 1,
	rep_addone(J,K).

rep_get_rand(No,_,R,R):-
	length(R,No),!.

rep_get_rand(No,Max,L,R):-
	length(L,LLen),
	LLen < No,
	new_rand(NewR,Max),
	not(member(NewR,L)),
	rep_get_rand(No,Max,[NewR|L],R).


new_rand(I,Max):- I is random(Max).

new_rand(I,Max):- new_rand(I,Max).


/*

selection of Nature texts for double-markup: 3, 12, 13

set_of_random(3,15,P).

P = [13, 12, 3] 


Yes

selection of New Sci texts for double-markup: 7, 8, 9

32 ?- set_of_random(3,15,P).

P = [9, 8, 7] 


*/
