

% repeat_test.pl



% repeat all tests in one big go !
% do_all.

:- multifile atmosphericConcentration/3, atmosphericConcentration_Qual/3,
   changeInAtmosphericConcentration/3.

atmosphericConcentration(aa_,aa_,aa_).
changeInAtmosphericConcentration(aa_,aa_,aa_).
atmosphericConcentration_Qual(aa_,aa_,aa_).

% note: change assess to get required precision measure

%ilp_system(lime).
%ilp_system(foil).
%ilp_system(golem).

load_ilp_code:- ilp_system(lime),  [generateILP_lime].
load_ilp_code:- ilp_system(golem), [generateILP_golem].
load_ilp_code:- ilp_system(foil),  [generateILP_foil].

:- [xmlfilter],[read_Brill_ne],[generateILP],
   [coreference-all],[resolve_ref],[assess_kb],
   [nature_ontology],[rand],[clean_code].



:- dynamic posSent/3, ilp_system/1,
    apply_stemming/1, merge_pos/1, filter_pos/1, 
    min_word_frequency/1, 
    relation_under_test/1,relation_under_test_arity/1,
    relation_under_test_arg1/1,
    use_txt_mapping/1,add_concepts/1, add_ontology/1,
    add_context/1,add_nonsentence/1.


rt:- cdh,[repeat_test].

code_dir('/hame/stuart/AKT/KnowX/Prolog-060302/').
subdirDATA('/hame/stuart/AKT/KnowX/Nature/').
exp_dir('/hame/stuart/AKT/AKT-SA/EXP-GOLEM/'):- ilp_system(golem).
exp_dir('/hame/stuart/AKT/AKT-SA/EXP-FOIL/'):- ilp_system(foil).
exp_dir('/hame/stuart/AKT/AKT-SA/EXP-LIME/'):- ilp_system(lime).
%exp_dir('/hame/stuart/AKT/KnowX/Prolog-060302/EXP/').

%ilp_command('/hame/stuart/AKT/KnowX/FOIL/foil6 -n -v0 '):- ilp_system(foil).
ilp_command('/hame/stuart/AKT/KnowX/FOIL/foil6 -v0 '):- ilp_system(foil).
ilp_command('/hame/stuart/AKT/KnowX/GOLEM/golem '):- ilp_system(golem).
ilp_command('/hame/stuart/AKT/KnowX/LIME2/src/lime -f norec -b 1000 -z 1 '):- 
    ilp_system(lime).


test_list([

%[EXP,  RelnAbb,Stem, Merge, Filter,Freq,   TxtMap,Con,   Ont,   NonSent, Context, POS]

['Exp3A',  aC,     true,true,   true,  3,   false, false, false, false,    false, 'pos_3'],
['Exp3A',  aCQ,    true,true,   true,  3,   false, false, false, false,    false, 'pos_2'],
['Exp3A',  cAC,    true,true,   true,  3,   false, false, false, false,    false, 'pos_2'],

['Exp3B',  aC,     true,true,   true,  3,   true,  false, false, false,    false, 'pos_3'],
['Exp3B',  aCQ,    true,true,   true,  3,   true,  false, false, false,    false, 'pos_2'],
['Exp3B',  cAC,    true,true,   true,  3,   true,  false, false, false,    false, 'pos_2'],

['Exp3C',  aC,     true,true,   true,  3,   false, true,  false, false,    false, 'pos_3'],
['Exp3C',  aCQ,    true,true,   true,  3,   false, true,  false, false,    false, 'pos_2'],
['Exp3C',  cAC,    true,true,   true,  3,   false, true,  false, false,    false, 'pos_2'],

['Exp3D',  aC,     true,true,   true,  3,   false, false, true,  false,    false, 'pos_3'],
['Exp3D',  aCQ,    true,true,   true,  3,   false, false, true,  false,    false, 'pos_2'],
['Exp3D',  cAC,    true,true,   true,  3,   false, false, true,  false,    false, 'pos_2'],


['Exp3E',  aC,     true,true,   true,  3,   false, false, false, true,     false, 'pos_3'],
['Exp3E',  aCQ,    true,true,   true,  3,   false, false, false, true,     false, 'pos_2'],
['Exp3E',  cAC,    true,true,   true,  3,   false, false, false, true,     false, 'pos_2'],

['Exp3F',  aC,     true,true,   true,  3,   false, false, false, false,    true,  'pos_3'],
['Exp3F',  aCQ,    true,true,   true,  3,   false, false, false, false,    true,  'pos_2'],
['Exp3F',  cAC,    true,true,   true,  3,   false, false, false, false,    true,  'pos_2'],

%[EXP,  RelnAbb,Stem, Merge, Filter,Freq,TxtMap,   Con,   Ont,   NonSent, Context, POS]

['Exp3G',  aC,     true,true,   true,  3,   false, false, false, true,     true,  'pos_3'],
['Exp3G',  aCQ,    true,true,   true,  3,   false, false, false, true,     true,  'pos_2'],
['Exp3G',  cAC,    true,true,   true,  3,   false, false, false, true,     true,  'pos_2']

/*
['Exp3H',  aC,     true,true,   true,  3,   true,  false, false, true,     true,  'pos_3'],
['Exp3H',  aCQ,    true,true,   true,  3,   true,  false, false, true,     true,  'pos_2'],
['Exp3H',  cAC,    true,true,   true,  3,   true,  false, false, true,     true,  'pos_2'],

['Exp3I',  aC,     true,true,   true,  3,   false, true,  false, true,     true,  'pos_3']
['Exp3I',  aCQ,    true,true,   true,  3,   false, true,  false, true,     true,  'pos_2'],
['Exp3I',  cAC,    true,true,   true,  3,   false, true,  false, true,     true,  'pos_2'],

['Exp3J',  aC,     true,true,   true,  3,   false, false, true,  true,     true,  'pos_3'],
['Exp3J',  aCQ,    true,true,   true,  3,   false, false, true,  true,     true,  'pos_2'],
['Exp3J',  cAC,    true,true,   true,  3,   false, false, true,  true,     true,  'pos_2'],

%[EXP,  RelnAbb,Stem, Merge, Filter,Freq,TxtMap,   Con,   Ont,   NonSent, Context, POS]

['Exp3K',  aC,     true,true,   true,  3,   true,  true,  false, true,     true,  'pos_3'],
['Exp3K',  aCQ,    true,true,   true,  3,   true,  true,  false, true,     true,  'pos_2'],
['Exp3K',  cAC,    true,true,   true,  3,   true,  true,  false, true,     true,  'pos_2'],

['Exp3L',  aC,     true,true,   true,  3,   true,  false, true,  true,     true,  'pos_3'],
['Exp3L',  aCQ,    true,true,   true,  3,   true,  false, true,  true,     true,  'pos_2'],
['Exp3L',  cAC,    true,true,   true,  3,   true,  false, true,  true,     true,  'pos_2'],

['Exp3M',  aC,     true,true,   true,  3,   false, true,  true,  true,     true,  'pos_3'],
['Exp3M',  aCQ,    true,true,   true,  3,   false, true,  true,  true,     true,  'pos_2'],
['Exp3M',  cAC,    true,true,   true,  3,   false, true,  true,  true,     true,  'pos_2'],

['Exp3N',  aC,     true,true,   true,  3,   true,  true,  true,  true,     true,  'pos_3'],
['Exp3N',  aCQ,    true,true,   true,  3,   true,  true,  true,  true,     true,  'pos_2'],

['Exp3N',  cAC,    true,true,   true,  3,   true , true,  true,  true,     true,  'pos_2']
*/
]).


p_dirs:-
test_list(I),get_dirs(I).

get_dirs([]):-!.
get_dirs([[EXP,RelnAbb|_]|L]):-
    concat(EXP,RelnAbb,Dir),
    nl,write('mkdir '),write(Dir),
    get_dirs(L).

    
do_all(Sys):-
    concat(Sys,'_test.pl',File),
    do_all(Sys,File,all).

% do_all/2: lime/foil/golem + option
% options
% all     : gen files + ilp + score
% gen     : gen files + ilp
% ilp     : ilp
% score   : score


do_all(Sys,X):-
    concat(Sys,'_test.pl',File),
    do_all(Sys,File,X).

do_all(Sys,F,all):- 
    retractall(ilp_system(_)),
    assertz(ilp_system(Sys)),
    load_ilp_code,
    retractall(data1(_)),
    exp_dir(EXPD),
    cd(EXPD),
    test_list(L),
    do_all_gen(L),!,
    nl,write(' Scoring: '),nl,
    do_all_score(L),!,
    nl,nl,
    p_results(F),
    cd_home.

do_all(Sys,_,gen):- 
    retractall(ilp_system(_)),
    assertz(ilp_system(Sys)),
    load_ilp_code,
    retractall(data1(_)),
    exp_dir(EXPD),
    cd(EXPD),
    test_list(L),
    do_all_gen(L),!,
    cd_home.

do_all(Sys,_,ilp):- 
    retractall(ilp_system(_)),
    assertz(ilp_system(Sys)),
    load_ilp_code,
    retractall(data1(_)),
    exp_dir(EXPD),
    cd(EXPD),
    test_list(L),
    do_all_ilp(L),!,
    cd_home.

do_all(Sys,F,score):- 
    retractall(ilp_system(_)),
    assertz(ilp_system(Sys)),
    load_ilp_code,
    retractall(data1(_)),
    exp_dir(EXPD),
    cd(EXPD),
    test_list(L),!,
    nl,write(' Scoring: '),nl,
    do_all_score(L),!,
    nl,nl,
    p_results(F),
    cd_home.
    
cdh:-cd_home.
cd_home:- code_dir(CODEDIR),cd(CODEDIR).

do_all_gen([]):-!.

do_all_gen([
[EXP,RelnAbb,Stem,Merge,Filter,Freq,TxtMap,Con,Ont,NONS,CTXT,POS]|L]):-

    concat(EXP,RelnAbb,Dir),
    nl,write(Dir),
    clean_db,
    exp_dir(EXPDIR),cd(EXPDIR),
    [POS],
    assertz(apply_stemming(Stem)),
    assertz(merge_pos(Merge)),
    assertz(filter_pos(Filter)),
    assertz(min_word_frequency(Freq)),
    assertz(use_txt_mapping(TxtMap)),
    assertz(add_concepts(Con)),
    assertz(add_ontology(Ont)),
    assertz(add_nonsentence(NONS)),
    assertz(add_context(CTXT)),
    rel_assns(RelnAbb),
    concat(EXPDIR,Dir,ADir),
    cd(ADir),!,
    gen(1),!,
%    do_ilp(EXP,RelnAbb),
    do_all_gen(L).

do_all_ilp([]):-!.

do_all_ilp([
[EXP,RelnAbb,Stem,Merge,Filter,Freq,TxtMap,Con,Ont,NONS,CTXT,POS]|L]):-

    concat(EXP,RelnAbb,Dir),
    nl,write(Dir),
    clean_db,
    exp_dir(EXPDIR),cd(EXPDIR),
    [POS],
    assertz(apply_stemming(Stem)),
    assertz(merge_pos(Merge)),
    assertz(filter_pos(Filter)),
    assertz(min_word_frequency(Freq)),
    assertz(use_txt_mapping(TxtMap)),
    assertz(add_concepts(Con)),
    assertz(add_ontology(Ont)),
    assertz(add_nonsentence(NONS)),
    assertz(add_context(CTXT)),
    rel_assns(RelnAbb),
    concat(EXPDIR,Dir,ADir),
    cd(ADir),!,
    do_ilp(EXP,RelnAbb),
    do_all_ilp(L).


/*
% modify xmlfilter as well!!
% learn arg2
rel_assns(RelnAbb):-    
    relns_rel(RelnAbb,Rel),
    reln_arg2_name(Rel,Rel2),
    assertz(relation_under_test(Rel2)),
    assertz(relation_under_test_arity(unary)),
    relns_arg1(RelnAbb,Arg1),
    assertz(relation_under_test_arg1(Arg1)).

*/

% learn full relation

rel_assns(RelnAbb):-    
    relns_rel(RelnAbb,Rel),
    assertz(relation_under_test(Rel)),
    relns_arity(RelnAbb,Ar),
    assertz(relation_under_test_arity(Ar)),
    relns_arg1(RelnAbb,Arg1),
    assertz(relation_under_test_arg1(Arg1)).

    
do_all_score([]):-!.

do_all_score([
[EXP,RelnAbb,Stem,Merge,Filter,Freq,TxtMap,Con,Ont,NONS,CTXT,POS]|L]):-

    concat(EXP,RelnAbb,Dir),
    nl,write(Dir),

    clean_db,
    exp_dir(EXPDIR),cd(EXPDIR),
    [POS],
    assertz(apply_stemming(Stem)),
    assertz(merge_pos(Merge)),
    assertz(filter_pos(Filter)),
    assertz(min_word_frequency(Freq)),
    assertz(use_txt_mapping(TxtMap)),
    assertz(add_concepts(Con)),
    assertz(add_ontology(Ont)),
    assertz(add_nonsentence(NONS)),
    assertz(add_context(CTXT)),

    rel_assns(RelnAbb),
    concat(EXPDIR,Dir,ADir),
    cd(ADir),!,
    concat('ilp-rules',Dir,Pre),

% move golem .r files, gzip ilp input files
    move_files(1,Dir),
    try_shell('gzip ilp-file*'),

    score_all(Pre),

    do_all_score(L).

move_files(_,_):-ilp_system(lime),!.
move_files(_,_):-ilp_system(foil),!.
move_files(11,_):- try_shell('rm junk'),!.
move_files(I,DIR):-
    ilp_system(golem),
    % move the .r file to ilp-rulesExpXY
    concat('mv ilp-file',I,CMD0),
    concat(CMD0,'.r ',CMD1),
    concat(CMD1,'ilp-rules',CMD2),
    concat(CMD2,DIR,CMD3),
    concat(CMD3,I,CMD4),
    try_shell(CMD4),!,
    J is I + 1,
    move_files(J,DIR).

    
do_all_foil([]):-!.
do_all_foil([[EXP,RelnAbb|_]|L]):-
    concat(EXP,RelnAbb,Dir),
    exp_dir(EXPDIR),
    concat(EXPDIR,Dir,ADir),
    rep_do_ilp(ADir,Dir,1),!,
    do_all_foil(L).

do_ilp(EXP,RelnAbb):-
    concat(EXP,RelnAbb,Dir),
    exp_dir(EXPDIR),
    concat(EXPDIR,Dir,ADir),
    rep_do_ilp(ADir,Dir,1),!.

rep_do_ilp(_,_,11):-!.

rep_do_ilp(ADir,Dir,I):-
    ilp_system(foil),
    concat('/ilp-file',I,FF),
    concat('/ilp-rules',Dir,FR0),
    concat(FR0,I,FR),

    concat(' < ',ADir,C1),
    concat(C1,FF,C2),

    concat(' > ',ADir,C3),
    concat(C3,FR,C4),

    ilp_command(ILPC),
    concat(ILPC,C2,C5),
    concat(C5,C4,Command),
    try_shell(Command),
    J is I + 1,
    rep_do_ilp(ADir,Dir,J).
    
rep_do_ilp(ADir,Dir,I):-
    ilp_system(lime),
    concat('/ilp-file',I,FF),
    concat('/ilp-rules',Dir,FR0),
    concat(FR0,I,FR),

    concat(' ',ADir,C1),
    concat(C1,FF,C2),

    concat(' > ',ADir,C3),
    concat(C3,FR,C4),

    ilp_command(ILPC),
    concat(ILPC,C2,C5),
    concat(C5,C4,Command),
    write(Command),nl,
%    try_shell(Command),
    J is I + 1,
    rep_do_ilp(ADir,Dir,J).
    
rep_do_ilp(ADir,Dir,I):-
    ilp_system(golem),
    concat('/ilp-file',I,FF),
    concat(' ',ADir,C1),
    concat(C1,FF,C2),

    ilp_command(ILPC),
    concat(ILPC,C2,C3),
    concat(C3,' > junk',Command),
    try_shell(Command),

    J is I + 1,
    rep_do_ilp(ADir,Dir,J).
    
    
try_shell(Command):-
    shell(Command).
try_shell(_):-!.

relation_under_test_concept('AtmosphericConcentration').

reln_arg2_name('atmosphericConcentration','atmCSarg2').
reln_arg2_name('atmosphericConcentration_Qual','atmCQarg2').
reln_arg2_name('changeInAtmosphericConcentration','cACarg2').

relns_rel(cn,'concept').
relns_rel(aC,'atmosphericConcentration').
relns_rel(aCQ,'atmosphericConcentration_Qual').
relns_rel(cAC,'changeInAtmosphericConcentration').

relns_arity(cn,unary).
relns_arity(aC,binary).
relns_arity(aCQ,binary).
relns_arity(cAC,binary).

relns_arg1(cn,na).
relns_arg1(aC,'Gas').
relns_arg1(aCQ,'Gas').
relns_arg1(cAC,'Gas').


clean_db:-
    retractall(posSent(_,_,_)),
    retractall(apply_stemming(_)), 
    retractall(merge_pos(_)), 
    retractall(filter_pos(_)), 
    retractall(min_word_frequency(_)), 
    retractall(relation_under_test(_)),
    retractall(relation_under_test_arity(_)),
    retractall(relation_under_test_arg1(_)),
    retractall(use_txt_mapping(_)),
    retractall(add_concepts(_)), 
    retractall(add_ontology(_)),
    retractall(add_nonsentence(_)),
    retractall(add_context(_)).
    
    
    
% these are not varied:

learning_input(all).
%learning_input(tgtOnly). % use only sentences with a target
%learning_input(tgtPlus).  % use target sentences plus other sentences
                           % containing target terms, see writeFOIL.pl

%apply_coreference(true).
apply_coreference(false).


%------------------------------------------------------------

% define the location of the language data files 



% define the list of files to be processed - training and testing


file_list(testing,['nature-1',
                    'nature-2','nature-3',
		    'nature-4','nature-5','nature-6',
		    'nature-7','nature-8','nature-9',
		    'nature-10',
		    'nature-11','nature-12','nature-13',
		    'nature-14','nature-15',
                    'new-scientist-1',
                    'new-scientist-2','new-scientist-3',
		    'new-scientist-4','new-scientist-5','new-scientist-6',
		    'new-scientist-7','new-scientist-8','new-scientist-9',
		    'new-scientist-10',
		    'new-scientist-11','new-scientist-12','new-scientist-13',
		    'new-scientist-14','new-scientist-15']).


file_list(training,['nature-1',
                    'nature-2','nature-3',
		    'nature-4','nature-5','nature-6',
		    'nature-7','nature-8','nature-9',
		    'nature-10',
		    'nature-11','nature-12','nature-13',
		    'nature-14','nature-15',
                    'new-scientist-1',
                    'new-scientist-2','new-scientist-3',
		    'new-scientist-4','new-scientist-5','new-scientist-6',
		    'new-scientist-7','new-scientist-8','new-scientist-9',
		    'new-scientist-10',
		    'new-scientist-11','new-scientist-12','new-scientist-13',
		    'new-scientist-14','new-scientist-15']).


p_results(F):-
findall(I,data1(I),IL),cdh,tell(F),write_res(IL),told.

write_res([]):-!.
write_res([[Pre,RSS,RTT,PSS,PTT]|L]):-
    ilp_system(ILP),
    nl,write('data(\''),write(Pre),write('\','),
    nl,write('\''),write(ILP),write('\','),
    nl,write('\%  recall:'),
    nl,write(RSS),write(','),
    nl,write(RTT),write(','),
    nl,write('\%  precision:'),
    nl,write(PSS),write(','),
    nl,write(PTT),write(').'),!,
    write_res(L).
