

% repeat_test.pl



% repeat all tests in one big go !
% do_all.

:- multifile atmosphericConcentration/3, atmosphericConcentration_Qual/3,
changeInAtmosphericConcentration/3.

atmosphericConcentration(aa_,aa_,aa_).
atmosphericConcentration_Qual(aa_,aa_,aa_).
changeInAtmosphericConcentration(aa_,aa_,aa_).

% note: change assess to get required precision measure

:- [xmlfilter],[read_Brill_ne],[writeFOIL_ont],
   [coreference-all],[resolve_ref],[assess_kb],
   [nature_ontology],[rand],[clean_code].

:- dynamic posSent/3, 
    apply_stemming/1, merge_pos/1, filter_pos/1, 
    min_word_frequency/1, 
    relation_under_test/1,relation_under_test_arity/1,
    relation_under_test_arg1/1,
    use_txt_mapping/1,add_concepts/1, add_ontology/1,
    add_context/1,add_nonsentence/1.

rt:- cdh,[repeat_test].


test_list([

%[EXP,  RelnAbb,Stem, Merge, Filter,Freq,TxtMap,Con,   Ont,   NonSent, Context, POS]
/*
['Exp1A',  aC,     true,true,   true,  1,   false, false, false, true, true, 'pos_1'],
['Exp1A',  aCQ,    true,true,   true,  1,   false, false, false, true, true, 'pos_1'],
['Exp1A',  cAC,    true,true,   true,  1,   false, false, false, true, true, 'pos_1'],


['Exp1B',  aC,     true,true,   true,  1,   false, false, false, true, true, 'pos_3'],
['Exp1B',  aCQ,    true,true,   true,  1,   false, false, false, true, true, 'pos_2'],
['Exp1B',  cAC,    true,true,   true,  1,   false, false, false, true, true, 'pos_2'],

['Exp1C',  aC,     true,true,   true,  1,   true,  false, false, true, true, 'pos_3'],
['Exp1C',  aCQ,    true,true,   true,  1,   true,  false, false, true, true, 'pos_2'],
['Exp1C',  cAC,    true,true,   true,  1,   true,  false, false, true, true, 'pos_2'],

%[EXP,  RelnAbb,Stem, Merge, Filter,Freq,TxtMap,Con,   Ont,   NonSent, Context, POS]

['Exp1D',  aC,     true,true,   true,  1,   false, true,  false, true, true, 'pos_3'],
['Exp1D',  aCQ,    true,true,   true,  1,   false, true,  false, true, true, 'pos_2'],
['Exp1D',  cAC,    true,true,   true,  1,   false, true,  false, true, true, 'pos_2'],


['Exp1E',  aC,     true,true,   true,  1,   true,  false, true,  true, true, 'pos_3'],
['Exp1E',  aCQ,    true,true,   true,  1,   true,  false, true,  true, true, 'pos_2'],
['Exp1E',  cAC,    true,true,   true,  1,   true,  false, true,  true, true, 'pos_2'],


['Exp1F',  aC,     true,true,   true,  1,   false, true,  true,  true, true, 'pos_3'],
['Exp1F',  aCQ,    true,true,   true,  1,   false, true,  true,  true, true, 'pos_2'],
['Exp1F',  cAC,    true,true,   true,  1,   false, true,  true,  true, true, 'pos_2'],


['Exp1G',  aC,     true,true,   true,  1,   true, true,  true,  true, true, 'pos_3'],
['Exp1G',  aCQ,    true,true,   true,  1,   true, true,  true,  true, true, 'pos_2'],
['Exp1G',  cAC,    true,true,   true,  1,   true, true,  true,  true, true, 'pos_2'],


%[EXP,  RelnAbb,Stem, Merge, Filter,Freq,TxtMap,Con,   Ont,   NonSent, Context, POS]
*/

['Exp5B',  aC,     true,true,   true,  5,   false, false, false, false, true, 'pos_3']

/*
['Exp5Btf',  aC,     true,true,   true,  5,   false, false, false, true, false, 'pos_3'],
['Exp5Btf',  aCQ,    true,true,   true,  5,   false, false, false, true, false, 'pos_2'],
['Exp5Btf',  cAC,    true,true,   true,  5,   false, false, false, true, false, 'pos_2'],


['Exp5Bft',  aC,     true,true,   true,  5,   false, false, false, false, true, 'pos_3'],
['Exp5Bft',  aCQ,    true,true,   true,  5,   false, false, false, false, true, 'pos_2'],
['Exp5Bft',  cAC,    true,true,   true,  5,   false, false, false, false, true, 'pos_2']

*/
/*
['Exp5A',  aC,     true,true,   true,  5,   false, false, false, true, true, 'pos_1'],
['Exp5A',  aCQ,    true,true,   true,  5,   false, false, false, true, true, 'pos_1'],
['Exp5A',  cAC,    true,true,   true,  5,   false, false, false, true, true, 'pos_1'],

['Exp5B',  aC,     true,true,   true,  5,   false, false, false, true, true, 'pos_3'],
['Exp5B',  aCQ,    true,true,   true,  5,   false, false, false, true, true, 'pos_2'],
['Exp5B',  cAC,    true,true,   true,  5,   false, false, false, true, true, 'pos_2'],

['Exp5C',  aC,     true,true,   true,  5,   true,  false, false, true, true, 'pos_3'],
['Exp5C',  aCQ,    true,true,   true,  5,   true,  false, false, true, true, 'pos_2'],
['Exp5C',  cAC,    true,true,   true,  5,   true,  false, false, true, true, 'pos_2'],

%[EXP,  RelnAbb,Stem, Merge, Filter,Freq,TxtMap,Con,   Ont,   NonSent, Context, POS]

['Exp5D',  aC,     true,true,   true,  5,   false, true,  false, true, true, 'pos_3'],
['Exp5D',  aCQ,    true,true,   true,  5,   false, true,  false, true, true, 'pos_2'],
['Exp5D',  cAC,    true,true,   true,  5,   false, true,  false, true, true, 'pos_2'],


['Exp5E',  aC,     true,true,   true,  5,   true,  false, true,  true, true, 'pos_3'],
['Exp5E',  aCQ,    true,true,   true,  5,   true,  false, true,  true, true, 'pos_2'],
['Exp5E',  cAC,    true,true,   true,  5,   true,  false, true,  true, true, 'pos_2'],


['Exp5F',  aC,     true,true,   true,  5,   false, true,  true,  true, true, 'pos_3'],
['Exp5F',  aCQ,    true,true,   true,  5,   false, true,  true,  true, true, 'pos_2'],
['Exp5F',  cAC,    true,true,   true,  5,   false, true,  true,  true, true, 'pos_2'],

['Exp5G',  aC,     true,true,   true,  5,   true, true,  true,  true, true, 'pos_3'],
['Exp5G',  aCQ,    true,true,   true,  5,   true, true,  true,  true, true, 'pos_2'],
['Exp5G',  cAC,    true,true,   true,  5,   true, true,  true,  true, true, 'pos_2']
*/

]).


p_dirs:-
test_list(I),get_dirs(I).

get_dirs([]):-!.
get_dirs([[EXP,RelnAbb|_]|L]):-
    concat(EXP,RelnAbb,Dir),
    nl,write('mkdir '),write(Dir),
    get_dirs(L).

    
do_all:- 
    retractall(data1(_)),
    cd('/home/aitken/KnowX/Prolog/EXP/'),
    test_list(L),
    do_all_gen(L),!,
    nl,write(' Scoring: '),nl,
    do_all_score(L),!,
    nl,nl,
    p_results,
    cd_home.
    
cdh:-cd_home.
cd_home:- cd('/home/aitken/KnowX/Prolog/').

do_all_gen([]):-!.

do_all_gen([
[EXP,RelnAbb,Stem,Merge,Filter,Freq,TxtMap,Con,Ont,NONS,CTXT,POS]|L]):-

    concat(EXP,RelnAbb,Dir),
    nl,write(Dir),
    clean_db,
    cd('/home/aitken/KnowX/Prolog/EXP/'),
    [POS],
    assertz(apply_stemming(Stem)),
    assertz(merge_pos(Merge)),
    assertz(filter_pos(Filter)),
    assertz(min_word_frequency(Freq)),
    assertz(use_txt_mapping(TxtMap)),
    assertz(add_concepts(Con)),
    assertz(add_ontology(Ont)),
    assertz(add_nonsentence(NONS)),
    assertz(add_context(CTXT)),
    
    rel_assns(RelnAbb),
    
    concat('/home/aitken/KnowX/Prolog/EXP/',Dir,ADir),
    cd(ADir),!,
    gen(1),!,
    do_foil(EXP,RelnAbb),
    do_all_gen(L).
/*
% modify xmlfilter as well!!
% learn arg2
rel_assns(RelnAbb):-    
    relns_rel(RelnAbb,Rel),
    reln_arg2_name(Rel,Rel2),
    assertz(relation_under_test(Rel2)),
    assertz(relation_under_test_arity(unary)),
    relns_arg1(RelnAbb,Arg1),
    assertz(relation_under_test_arg1(Arg1)).

*/

% learn full relation

rel_assns(RelnAbb):-    
    relns_rel(RelnAbb,Rel),
    assertz(relation_under_test(Rel)),
    relns_arity(RelnAbb,Ar),
    assertz(relation_under_test_arity(Ar)),
    relns_arg1(RelnAbb,Arg1),
    assertz(relation_under_test_arg1(Arg1)).

    
do_all_score([]):-!.

do_all_score([
[EXP,RelnAbb,Stem,Merge,Filter,Freq,TxtMap,Con,Ont,NONS,CTXT,POS]|L]):-

    concat(EXP,RelnAbb,Dir),
    nl,write(Dir),

    clean_db,
    cd('/home/aitken/KnowX/Prolog/EXP/'),
    [POS],
    assertz(apply_stemming(Stem)),
    assertz(merge_pos(Merge)),
    assertz(filter_pos(Filter)),
    assertz(min_word_frequency(Freq)),
    assertz(use_txt_mapping(TxtMap)),
    assertz(add_concepts(Con)),
    assertz(add_ontology(Ont)),
    assertz(add_nonsentence(NONS)),
    assertz(add_context(CTXT)),

    rel_assns(RelnAbb),
    
    concat('/home/aitken/KnowX/Prolog/EXP/',Dir,ADir),
    cd(ADir),!,

    concat('foil-rules',Dir,Pre),
    score_all(Pre),

    do_all_score(L).
    
    
do_all_foil([]):-!.
do_all_foil([[EXP,RelnAbb|_]|L]):-
    concat(EXP,RelnAbb,Dir),
    concat('/home/aitken/KnowX/Prolog/EXP/',Dir,ADir),
    rep_do_foil(ADir,Dir,1),!,
    do_all_foil(L).

do_foil(EXP,RelnAbb):-
    concat(EXP,RelnAbb,Dir),
    concat('/home/aitken/KnowX/Prolog/EXP/',Dir,ADir),
    rep_do_foil(ADir,Dir,1),!.

rep_do_foil(_,_,11):-!.
rep_do_foil(ADir,Dir,I):-
    concat('/foil-file',I,FF),
    concat('/foil-rules',Dir,FR0),
    concat(FR0,I,FR),

    concat(' < ',ADir,C1),
    concat(C1,FF,C2),

    concat(' > ',ADir,C3),
    concat(C3,FR,C4),

    concat('/home/aitken/FOIL/Temp/foil6 -n -v0 ',C2,C5),
    concat(C5,C4,Command),
%    nl,write(Command),
    shell(Command),
    J is I + 1,
    rep_do_foil(ADir,Dir,J).
    

rep_do_foil(ADir,Dir,I):-
    concat('/foil-file',I,FF),
    concat('/foil-rules',Dir,FR0),
    concat(FR0,I,FR),

    concat(' < ',ADir,C1),
    concat(C1,FF,C2),

    concat(' > ',ADir,C3),
    concat(C3,FR,C4),

    concat('/home/aitken/FOIL/Temp/foil6 -n -v0 ',C2,C5),
    concat(C5,C4,Command),!,
    nl,write(Command),
    J is I + 1,
    rep_do_foil(ADir,Dir,J).
    

relation_under_test_concept('AtmosphericConcentration').

reln_arg2_name('atmosphericConcentration','atmCSarg2').
reln_arg2_name('atmosphericConcentration_Qual','atmCQarg2').
reln_arg2_name('changeInAtmosphericConcentration','cACarg2').

relns_rel(cn,'concept').
relns_rel(aC,'atmosphericConcentration').
relns_rel(aCQ,'atmosphericConcentration_Qual').
relns_rel(cAC,'changeInAtmosphericConcentration').

relns_arity(cn,unary).
relns_arity(aC,binary).
relns_arity(aCQ,binary).
relns_arity(cAC,binary).

relns_arg1(cn,na).
relns_arg1(aC,'Gas').
relns_arg1(aCQ,'Gas').
relns_arg1(cAC,'Gas').


clean_db:-
    retractall(posSent(_,_,_)),
    retractall(apply_stemming(_)), 
    retractall(merge_pos(_)), 
    retractall(filter_pos(_)), 
    retractall(min_word_frequency(_)), 
    retractall(relation_under_test(_)),
    retractall(relation_under_test_arity(_)),
    retractall(relation_under_test_arg1(_)),
    retractall(use_txt_mapping(_)),
    retractall(add_concepts(_)), 
    retractall(add_ontology(_)),
    retractall(add_nonsentence(_)),
    retractall(add_context(_)).
    
    
    
% these are not varied:

learning_input(all).
% learning_input(tgtOnly). % use only sentences with a target
%learning_input(tgtPlus).  % use target sentences plus other sentences
                           % containing target terms, see writeFOIL.pl

%apply_coreference(true).
apply_coreference(false).


%------------------------------------------------------------

% define the location of the language data files 

subdirDATA('/home/aitken/KnowX/Nature/').

% define the list of files to be processed - training and testing


file_list(testing,['nature-1',
                    'nature-2','nature-3',
		    'nature-4','nature-5','nature-6',
		    'nature-7','nature-8','nature-9',
		    'nature-10',
		    'nature-11','nature-12','nature-13',
		    'nature-14','nature-15',
                    'new-scientist-1',
                    'new-scientist-2','new-scientist-3',
		    'new-scientist-4','new-scientist-5','new-scientist-6',
		    'new-scientist-7','new-scientist-8','new-scientist-9',
		    'new-scientist-10',
		    'new-scientist-11','new-scientist-12','new-scientist-13',
		    'new-scientist-14','new-scientist-15']).


file_list(training,['nature-1',
                    'nature-2','nature-3',
		    'nature-4','nature-5','nature-6',
		    'nature-7','nature-8','nature-9',
		    'nature-10',
		    'nature-11','nature-12','nature-13',
		    'nature-14','nature-15',
                    'new-scientist-1',
                    'new-scientist-2','new-scientist-3',
		    'new-scientist-4','new-scientist-5','new-scientist-6',
		    'new-scientist-7','new-scientist-8','new-scientist-9',
		    'new-scientist-10',
		    'new-scientist-11','new-scientist-12','new-scientist-13',
		    'new-scientist-14','new-scientist-15']).


p_results:-
findall(I,data1(I),IL),write_res(IL).

write_res([]):-!.
write_res([[Pre,RSS,RTT,PSS,PTT]|L]):-
    nl,write('data(\''),write(Pre),write('\','),
    nl,write('\%  recall:'),
    nl,write(RSS),write(','),
    nl,write(RTT),write(','),
    nl,write('\%  precision:'),
    nl,write(PSS),write(','),
    nl,write(PTT),write(').'),!,
    write_res(L).
