
% resolve_ref.pl

% is_ontology_term/1 must be defined, see chemElement_ontology.pl

resolve_ref([],_,_,[]):-!.
resolve_ref([posSent(Sent,_,_,PRONOUN)|L],NOUNCLASS,POSList,
	    [posSent(Sent,POS,ONTTerm)|M]):-
	is_pronoun(PRONOUN),
	member(class(Sent,CLASS,PRONOUN),NOUNCLASS),
	member(class(Sent1,CLASS,ONTTerm),NOUNCLASS),
	is_ontology_term(ONTTerm),
        member(posSent(Sent1,POS,ONTTerm),POSList),!,
	resolve_ref(L,NOUNCLASS,POSList,M).

resolve_ref([posSent(Sent,_,_,TERM)|L],NOUNCLASS,POSList,
	    [posSent(Sent,POSNOUN,TERM)|M]):-
	is_pronoun(PRONOUN),
	member(class(Sent,CLASS,PRONOUN),NOUNCLASS),
	member(class(Sent1,CLASS,NOUN),NOUNCLASS),
        member(posSent(Sent1,POSNOUN,NOUN),POSList),
        is_noun(POSNOUN),!,
	resolve_ref(L,NOUNCLASS,POSList,M).

resolve_ref([posSent(Sent,_,POS,TERM)|L],NOUNCLASS,POSList,
	    [posSent(Sent,POS,TERM)|M]):-
	resolve_ref(L,NOUNCLASS,POSList,M).


is_noun(X):- map_class(X,n).

is_pronoun(X):- firstperson(X).
is_pronoun(X):- sndperson(X).
is_pronoun(X):- thrdperson(X).


write_coref([],[]):-!.
write_coref([posSent(_,_,_,I)|J],[posSent(_,_,K)|L]):-
	is_pronoun(I),
	write(' ['),write(I), write('-->'),write(K),write(']'),
	write_coref(J,L).
write_coref([posSent(_,_,_,I)|J],[posSent(_,_,I)|L]):-
	write_coref(J,L).
