% stats.pl

stats(I):-
	data(I,ILP,R,RL,P,PL),
	reconcile(R,RL,RR),
	reconcile(P,PL,PP),
	ave(RR,RRave),
	ave(PP,PPave),

	conf_test(RR,TRR),
	conf_test(PP,TPP),

        rep_f(PP,RR,FF),
        ave(FF,FFave),
        conf_test(FF,TFF),
        max(-0.001,FF,FMAX),
        

/*
	nl,write(I),
	nl,write(ILP),
	nl,write('Precision ave: '),write(PPave),
	nl,write('    +/- 5\%:    '),write(TPP),
	nl,write('Recall ave:    '),write(RRave),
	nl,write('    +/- 5\%:    '),write(TRR),

	nl,write('F ave: '),write(FFave),
	nl,write('    +/- 5\%:    '),write(TFF),
	nl,write('F max: '),write(FMAX),
*/

%nl,write(I),write(' & '), format('~2f',FFave).

    nl, write('%'),write(I),write('-'),write(ILP),nl,
    write(' & '),format('~2f',PPave),
    %write(' ('),format('~2f',TPP),write(')'),
    write(' & '),format('~2f',RRave),
    %write(' ('),format('~2f',TRR),write(')'),
    write(' & '), format('~2f',FFave),nl.
    %write(' ('),format('~2f',TFF),write(')'),nl.

%    write(') ['),format('~2f',FMAX),write('] & '),nl.


/*
stats(I):-
	data(I,R,RL,P,PL,WS,TUP),
	reconcile(R,RL,RR),
	reconcile(P,PL,PP),
	ave(RR,RRave),
	ave(PP,PPave),
	ave(WS,WSave),
	ave(TUP,TUPave),

/*	conf_test(RR,TRR),
	conf_test(PP,TPP),
	conf_test(WS,TWS),
	conf_test(TUP,TTUP),
*/
        rep_f(PP,RR,FF),
        ave(FF,FFave),
%        conf_test(FF,TFF),
        max(-0.001,FF,FMAX),

	nl,write(I),
	nl,write('Recall ave:    '),write(RRave),
	nl,write('    +/- 5\%:    '),write(TRR),
	nl,write('Precision ave: '),write(PPave),
	nl,write('    +/- 5\%:    '),write(TPP),
	nl,write('F ave: '),write(FFave),
	nl,write('    +/- 5\%:    '),write(TFF),
	nl,write('F max: '),write(FMAX),
	nl,write('Word Set ave:  '),write(WSave),
	nl,write('    +/- 5\%:    '),write(TWS),
	nl,write('Rules ave:    '),write(TUPave),
	nl,write('    +/- 5\%:    '),write(TTUP).
*/

max(I,[],I):-!.
max(I,[J|K],M):-
    J > I,!,
    max(J,K,M).

max(I,[_|K],M):-
    max(I,K,M).



rep_f([],[],[]):-!.
rep_f([A|L],[B|M],[C|R]):-
    f_score(A,B,C),
    rep_f(L,M,R).

f_score(0,0,0):-!.
f_score(P,R,F):-
    F is ((2 * P * R)/(P+R)).


ave(L,A):-
	sum(L,Sum,No),
        divn(Sum,No,A).

divn(0,0,0):-!.
divn(Sum,No,A):-
	A is Sum/No.

sum([],0,0):-!.
sum([I|J],K,L):-
	sum(J,KK,LL),
	K is KK + I,
	L is LL + 1.
	
reconcile([],[],[]):-!.
reconcile([0|L],[0|M],[1|R]):-!,
	reconcile(L,M,R).
reconcile([_|L],[0|M],[0|R]):-
	reconcile(L,M,R).
reconcile([A|L],[B|M],[C|R]):-
	C is A/B,
	reconcile(L,M,R).



conf_test(L,Conf):- 
	length(L,10),
	ave(L,M),
	sum_diff_sq(L,M,SSqq),
	SSq is SSqq/9,
	S is sqrt(SSq),
	SN is S/sqrt(10),
	Conf is 2.26 * SN.

% t_test([31.31,32.14,31.14,31.22,28.87,29.37,32.37,30.70,30.41,30.07],T).
t_test(L,T):- 
	length(L,10),
	ave(L,M),
	sum_diff_sq(L,M,SSqq),
	SSq is SSqq/9,
	S is sqrt(SSq),
	SN is S/sqrt(10),
	T is M/SN.

sum_diff_sq([],_,0):-!.
sum_diff_sq([A|L],M,R):-
	sum_diff_sq(L,M,R0),
	R is R0 + ((A-M)*(A-M)).
	
